UIPanelWindows["SpellTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

local SpellTrackerVersion="0.2";

SpellTracker = {};
SpellTracker.BARS = {}; -- stock les abbres qui sont cr au dbut et sont dans le cache
SpellTracker.ScrollValue = 0; -- valeur de la scrolbar virtuelle
SpellTracker.myPlayerGUID = UnitGUID("player");

function SpellTrackerFrame_Init(self)
	SpellTrackerDB = SpellTrackerDB or {};
	
	SpellTrackerDB.SPELLS = SpellTrackerDB.SPELLS or {}; -- stock les infos a afficher
	
	SpellTrackerDB.Params = SpellTrackerDB.Params or {};
	SpellTrackerDB.Params.SpellBarHeight = SpellTrackerDB.Params.SpellBarHeight or 20;
	SpellTrackerDB.Params.FrameWidth = SpellTrackerDB.Params.FrameWidth or 400;
	SpellTrackerDB.Params.FrameHeight = SpellTrackerDB.Params.FrameHeight or 400;
	SpellTrackerDB.Params.DefaultCountSpellsToTrack = 50; -- pilote le nombre de barres qui vont tre cres  l'avance
	
	SpellTrackerDB.SPELLSTOTTRACK = SpellTrackerDB.SPELLSTOTTRACK or {}; -- stock les sort  traquer
	
	SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker r"..SpellTrackerVersion);
	
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:SetWidth(SpellTrackerDB.Params.FrameWidth);
		SpellTrackerFrame:SetHeight(SpellTrackerDB.Params.FrameHeight);
	end
end
function SpellTrackerMinimapButton_OnClick(self)
    if (SpellTrackerFrame) then
        if(SpellTrackerFrame:IsVisible() ) then
            SpellTrackerFrame:Hide();
		else
            SpellTrackerFrame:Show();
			SpellTracker:UpdateFrame();
		end
    end
end
function hideSpellTrackerFrameButton_OnClick(self) -- Bouton pour fermer la mainFrame
	if (SpellTrackerFrame) then
        SpellTrackerFrame:Hide();
    end
end
function resetSpellTrackerButton_OnClick(self) -- Bouton pour reset les sorts traqus
	SpellTrackerDB.SPELLS = {};
	SpellTracker:UpdateFrame();
end
function SpellTrackerBar_OnEnter(self) -- affiche des infos sup sur les sort traqus
	if ( self.VAR.Used ) then 
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(self.VAR.SpellName);
		GameTooltip:AddDoubleLine("Nombre de Cast :",self.VAR.CountCast);
		GameTooltip:AddDoubleLine("Target Type :",self.VAR.TargetType);
		
		-- self.SpellHitType vaut "Heal" ou "Damage"
		GameTooltip:AddDoubleLine(self.VAR.SpellHitType.." :","|cFF33FF33"..string.format("%.0f", self.VAR.SpellHitAmount/1000).."K");
		GameTooltip:AddDoubleLine("Over"..self.VAR.SpellHitType.." :","|cFFFF9900"..string.format("%.0f", self.VAR.SpellOver/1000).."K");
		GameTooltip:AddDoubleLine(self.VAR.SpellHitType.." Crit : ","|cFF3366FF"..string.format("%.0f", self.VAR.SpellCritAmount/1000).."K");
		GameTooltip:Show();
	end
end
function SpellTrackerBar_OnLeave(self)
    GameTooltip:Hide();
end
function SpellTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("SpellTracker r"..SpellTrackerVersion);
end
function SpellTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function SpellTrackerResizeFrame_OnEnter(self) -- widget de redimentionnement -- survol IN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(false);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(1);
	end
end
function SpellTrackerResizeFrame_OnLeave(self) -- widget de redimentionnement -- survol OUT
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(true);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(0);
	end
end
function SpellTrackerResizeFrame_OnMouseDown(self) -- widget de redimentionnement -- CLICK DOWN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame.isMovingOrSizing = false;
		SpellTrackerFrame:SetMinResize(80, 110);
		SpellTrackerFrame:SetMaxResize(800, 800);
		SpellTrackerFrame:StartSizing();
	end
end
function SpellTrackerResizeFrame_OnMouseUp(self) -- widget de redimentionnement -- CLICK UP
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:StopMovingOrSizing();
		SpellTrackerFrame:ClearAllPoints();
		SpellTrackerFrame.isMovingOrSizing = nil;
		SpellTrackerDB.Params.FrameWidth = SpellTrackerFrame:GetWidth();
		SpellTrackerDB.Params.FrameHeight = SpellTrackerFrame:GetHeight();
		SpellTracker:InitFrame(); -- on a redimentionn donc on reinit le layout
	end
end
function SpellTrackerFrameScrollLayout_OnLoad(self) -- chargement du container du grid
	self:RegisterForDrag("LeftButton");
	self:SetScrollChild(SpellTrackerFrameScrollLayoutContainer);
end
function SpellTrackerFrameScrollLayoutVirtualScrollBar_OnMouseWheel (self, delta, stepSize) -- se produit quand la molette de la sourie roule
	if ( delta ) then
		local minVal, maxVal = 0, SpellTrackerFrameScrollLayout:GetVerticalScrollRange();
		stepSize = 5;
		if ( delta == 1 ) then
			SpellTracker.ScrollValue = max(minVal, SpellTracker.ScrollValue - stepSize);
		else
			SpellTracker.ScrollValue = min(maxVal, SpellTracker.ScrollValue + stepSize);
		end
		local maxScroll = SpellTrackerFrameScrollLayout:GetVerticalScrollRange();
		local newScroll = maxScroll * SpellTracker.ScrollValue / 100;
		SpellTrackerFrameScrollLayout:SetVerticalScroll(newScroll); -- on change la valeur du scroll
	end
end	
function SpellTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); -- recuper les event de combat 
    self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Get Aggro
    self:RegisterEvent("PLAYER_REGEN_ENABLED");	-- Leave Aggro
end
function SpellTrackerFrame_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		SpellTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			SpellTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTrackerVersion.." LOADED");
			SpellTracker:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTrackerVersion.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	end
end
function SpellTracker:CreateBar(frmName)
    local GuiBar = CreateFrame("Button", frmName, SpellTrackerFrame, "SpellTrackerBarTemplate");
        
	GuiBar:RegisterForClicks("AnyUp");
	
	GuiBar.GUI = {};
	GuiBar.GUI.SpellIcon = _G[frmName.."StatusBarSpellHitSpellIcon"];
	GuiBar.GUI.SpellNameLabel = _G[frmName.."StatusBarSpellHitSpellNameLabel"];
	GuiBar.GUI.SpellHitLabel = _G[frmName.."StatusBarSpellHitSpellHitLabel"];
	GuiBar.GUI.SpellOverHitLabel = _G[frmName.."StatusBarSpellHitSpellOverHitLabel"];
	GuiBar.GUI.SpellCritAmountLabel = _G[frmName.."StatusBarSpellHitSpellCritAmountLabel"];
	GuiBar.GUI.StatusBarSpellHit = _G[frmName.."StatusBarSpellHit"];
	GuiBar.GUI.StatusBarSpellHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellHit:SetMinMaxValues(0, 100);
	GuiBar.GUI.StatusBarSpellOverHit = _G[frmName.."StatusBarSpellOverHit"];
	GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHit:SetMinMaxValues(0, 100);
	GuiBar.GUI.StatusBarSpellCritAmount = _G[frmName.."StatusBarSpellCritAmount"];
	GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmount:SetMinMaxValues(0, 100);
    
    GuiBar.VAR = {};
	GuiBar.VAR.SpellIconTex = nil; -- chemin de la texture du sort
	GuiBar.VAR.SpellId = 0; -- id du sort
	GuiBar.VAR.SpellName = "spell Name"; -- nom du sort
	GuiBar.VAR.SpellHitType = "Heal/Damage"; -- type du sort
	GuiBar.VAR.SpellHitAmount = 0; -- montant du sort
	GuiBar.VAR.SpellAmountTotal = 0; -- montant total du sort => Hit + Crit + Over
	GuiBar.VAR.SpellOver = 0; -- montant en trop du sort
	GuiBar.VAR.SpellCritAmount = 0; -- montant en critique du sort
	GuiBar.VAR.TargetType = ""; -- type de cible : mob ou player
	GuiBar.VAR.SpellTracked = false; -- si le spell est demand a traquer
	GuiBar.VAR.CountCast = 0; -- nombre de spell
	
	GuiBar.VAR.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	return GuiBar;
end
function SpellTracker:ResetBar(GuiBar)
	if ( GuiBar ) then
		GuiBar.GUI.SpellIcon:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.GUI.SpellNameLabel:SetText("");
		GuiBar.GUI.SpellHitLabel:SetText("");
		GuiBar.GUI.SpellOverHitLabel:SetText("");
		GuiBar.GUI.SpellCritAmountLabel:SetText("");
		GuiBar.GUI.StatusBarSpellHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
		GuiBar.VAR.Used = false;
	end
end
function SpellTracker:InitFrame()
	if ( #SpellTracker.BARS == 0 ) then
		local idx = 1;
		local countBarToCreate = SpellTrackerDB.Params.DefaultCountSpellsToTrack;
		for k=0,countBarToCreate do 
			local frmName = "SpellTrackerBar"..tostring(idx);
			local Bar = SpellTracker:CreateBar(frmName);
			--Bar:Hide();
			SpellTracker.BARS[idx] = Bar;
			idx = idx + 1;
		end
	end
	
	local offset = 5;
    local mFrameContainer = SpellTrackerFrameScrollLayoutContainer;
	local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
    nrowMax = math.ceil(#SpellTracker.BARS);
	mFrameContainer:SetWidth(SpellTrackerFrame:GetWidth() - offset);
	local mFrameWidth = mFrameContainer:GetWidth() - offset;
	itW = mFrameWidth - offset;
    itH = SpellTrackerDB.Params.SpellBarHeight;
	local heightMax = nrowMax * itH + offset*(nrowMax+1);
	mFrameContainer:SetHeight(heightMax);
	local mFrameHeight = mFrameContainer:GetHeight() - offset;
    
    local Row, Col = 0, 0;
	for idx, guiBar in pairs(SpellTracker.BARS) do
		if ( guiBar ) then
			guiBar:SetParent(mFrameContainer);
			Row = math.floor((idx-1));
			Col = (idx-1)- Row;
			TopLeftX = Col * itW + offset*(Col+1);
			TopLeftY = Row * itH * -1 - offset*(Row+1);
			guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", TopLeftX, TopLeftY);
			guiBar:SetWidth(itW);
			guiBar:SetHeight(itH);
			--guiBar:Hide();
		end
    end
end
function SpellTracker:UpdateFrame()
	local SpellListToSort = {};
	for spellIndexer, spellStruct in pairs(SpellTrackerDB.SPELLS) do
        if ( spellIndexer and spellStruct ) then 
			tinsert(SpellListToSort, spellStruct);
        end
    end
	
	sort(SpellListToSort, 
		function(x,y)
			if ( x and y ) then
				if  ( x.SpellTracked and y.SpellTracked ) then
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				elseif ( x.SpellTracked ) then 
					return true; 
				elseif ( y.SpellTracked ) then 
					return false;
				else -- not ( x.SpellTracked and y.SpellTracked ) 
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				end	
			end
		end);
	
	for i, bar in pairs(SpellTracker.BARS) do
		if ( bar ) then
			if ( bar.VAR.Used ) then -- la barre est utlise;
				SpellTracker:ResetBar(bar); -- on la reset, car la cahcher va porvoquer une erreur en combat
			end
		end
	end
	
	local idx = 1;
    for spellIndexer, spellStruct in pairs(SpellListToSort) do
		if ( spellIndexer ) then
            local GuiBar = SpellTracker.BARS[idx];
			idx = idx + 1;
            if ( GuiBar ) then
                GuiBar.GUI.SpellIcon:SetTexture(spellStruct.SpellIconTex); -- Spell Icon
				GuiBar.VAR.SpellIconTex = spellStruct.SpellIconTex;
				
				GuiBar.GUI.SpellNameLabel:SetText(tostring(spellStruct.SpellName).." x"..tostring(spellStruct.CountCast).." - "..tostring(spellStruct.TargetType)); -- Spell Name
				GuiBar.VAR.SpellName = spellStruct.SpellName;
				GuiBar.VAR.TargetType = spellStruct.TargetType;
				GuiBar.VAR.CountCast = spellStruct.CountCast;
				
				GuiBar.GUI.SpellHitLabel:SetText(string.format("%.0f", spellStruct.SpellHitAmount/1000).."K"); -- Spell Amount
				GuiBar.VAR.SpellHitAmount = spellStruct.SpellHitAmount;
				
				GuiBar.GUI.SpellOverHitLabel:SetText(string.format("%.0f", spellStruct.SpellOver/1000).."K"); -- Spell Over Amount
				GuiBar.VAR.SpellOver = spellStruct.SpellOver;
				
				GuiBar.GUI.SpellCritAmountLabel:SetText(string.format("%.0f", spellStruct.SpellCritAmount/1000).."K"); -- Spell Crit Amount
				GuiBar.VAR.SpellCritAmount = spellStruct.SpellCritAmount;
				
				local HitAmount = spellStruct.SpellHitAmount*100/spellStruct.SpellAmountTotal;
				local OverHitAmount = spellStruct.SpellOver*100/spellStruct.SpellAmountTotal;
				
				GuiBar.GUI.StatusBarSpellHit:SetValue(HitAmount);
				GuiBar.GUI.StatusBarSpellOverHit:SetValue(HitAmount+OverHitAmount);
				GuiBar.GUI.StatusBarSpellCritAmount:SetValue(100);
				
				GuiBar.VAR.SpellId = spellStruct.SpellId;
				GuiBar.VAR.SpellHitType = spellStruct.SpellHitType;
				GuiBar.VAR.SpellAmountTotal = spellStruct.SpellAmountTotal;
				
				GuiBar.VAR.SpellTracked = spellStruct.SpellTracked;
				
				GuiBar.VAR.Used = true;
            end
		end
	end
end
function SpellTracker:WhatIsThisGuid(GUIDNumber)
	if ( GUIDNumber ~= nil and GUIDNumber ~= "" ) then
		local maskedB = tonumber(GUIDNumber:sub(5,5), 16) % 8; 
		local knownTypes = {[0]="player", [1]="object", [3]="mob", [4]="pet", [5]="vehicle"};
		local result = knownTypes[maskedB] or "Unknow";
		return result; 
    end
    return "Unknow";
end
function SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local MyGUID = SpellTracker.myPlayerGUID;	
	if ( GUIDSRC == MyGUID ) then
		local TargetType = SpellTracker:WhatIsThisGuid(GUIDDST);
        if(EVENTTYPE == "SWING_DAMAGE") then --autoattack
			SpellTracker:UpdateSpell("Damage", TargetType, ...);
        elseif(	EVENTTYPE == "SPELL_PERIODIC_DAMAGE" 
				or EVENTTYPE == "SPELL_DAMAGE" 
				or EVENTTYPE == "DAMAGE_SPLIT" 
				or EVENTTYPE == "DAMAGE_SHIELD") then
			SpellTracker:UpdateSpell("Damage", TargetType, ...);
        elseif(EVENTTYPE == "ENVIRONMENTAL_DAMAGE") then
			SpellTracker:UpdateSpell("Damage", TargetType, ...);
        elseif(	EVENTTYPE == "SPELL_HEAL" 
				or EVENTTYPE == "SPELL_PERIODIC_HEAL") then
			SpellTracker:UpdateSpell("Heal", TargetType, ...);
        end
    end
end
function SpellTracker:UpdateSpell(SpellHitType, TargetType, ...) -- SpellHitType = Heal or Damage / TargetType = player or MOB / 
	local SPELLID, SPELLNAME, SPELLSCHOOL, AMOUNT, OVERKILL, SCHOOL, RESISTED, BLOCKED, ABSORBED, CRITICAL, GLANCING, CRUSHING;
	-- voir http://www.wowwiki.com/API_COMBAT_LOG_EVENT
	if ( SpellHitType == "Damage" ) then
		SPELLID, SPELLNAME, SPELLSCHOOL, AMOUNT, OVERKILL, SCHOOL, RESISTED, BLOCKED, ABSORBED, CRITICAL, GLANCING, CRUSHING = ...;
	elseif ( SpellHitType == "Heal" ) then
		SPELLID, SPELLNAME, SPELLSCHOOL, AMOUNT, OVERKILL, ABSORBED, CRITICAL = ...;
	end
	
	local SpellIndexer = tostring(SPELLNAME).."-"..TargetType;
	
	-- Init or not
	local SpellStruct = SpellTrackerDB.SPELLS[SpellIndexer] or {};
	SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount or 0; -- init ot not
	SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount or 0; -- init ot not
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal or 0; -- init ot not
	SpellStruct.SpellOver = SpellStruct.SpellOver or 0; -- init ot not
	SpellStruct.CountCast = SpellStruct.CountCast or 0;
	
	-- Affect
	SpellStruct.SpellIconTex = ""; -- chemin de la texture du sort
	SpellStruct.SpellId = SpellStruct.SpellId or SPELLID; -- id du sort
	SpellStruct.SpellName = SPELLNAME; -- nom du sort
	SpellStruct.SpellHitType = SpellHitType; -- type du sort
	SpellStruct.TargetType = TargetType;
	
	SpellStruct.SpellIconTex = GetSpellTexture(SPELLNAME);
	
	SpellStruct.CountCast = SpellStruct.CountCast + 1;
	
	AMOUNT = AMOUNT - OVERKILL; -- on dit que si on a que de l'over c'est que du perdu et donc 0 amount pusique amount est considr comme utile au contraire de over qui est inutile
	
	-- Crit or Hit => Var used = AMOUNT
	if ( CRITICAL == 1 ) then
		SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount + AMOUNT; -- montant en critique du sort on compte que amount par over
	else
		SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount + AMOUNT; -- montant en hit du sort
	end
	
	-- Over Hit ou Crit => Var used = OVERKILL
	if ( OVERKILL > 0 ) then
		SpellStruct.SpellOver = SpellStruct.SpellOver + OVERKILL; -- montant en trop du sort
	end

	if ( SpellTrackerDB.SPELLSTOTTRACK[SPELLID] ) then
		SpellStruct.SpellTracked = true; -- si le spell est demand a traquer
	else
		SpellStruct.SpellTracked = false;
	end
	
	-- Amount Total => Var used = AMOUNT & OVERKILL
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal + (AMOUNT + OVERKILL); -- montant total du sort => Normal + Crit + Over
	
	SpellStruct.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	-- on stock la struct
	SpellTrackerDB.SPELLS[SpellIndexer] = SpellStruct;
	
	-- On maj la frame
	SpellTracker:UpdateFrame();
end
